	LIST	p=16F84
	#include "P16F84.INC"
	__CONFIG _WDT_OFF&_LP_OSC&_PWRTE_ON&_CP_OFF
	errorlevel	-302	;     

;-----<   >-----

	cblock	0x0D	;    
	nomer		;     
	number		;     
	press		;      
	sposob		;     
	spcopy		;     
	on		;     
	off		;     
	regon		;     
	regoff		;     
	regkol1		;     
	regkol2		;     
	paus1		;   
	paus2		;   
	paus3		;   
	play1		;     
	play2		;     
	dlitel		;    
	charge1		;    
	charge2		;    
	charge3		;    
	delay1		;   
	delay2		;   
	delay3		;   
	endc		;   

	org	0
	goto	init

;-----<   >-----

select	bsf	PORTB,3		;    ""
	call	pauza
	bcf	PORTB,3
	call	pauza
	call	pauza
	return

down	bsf	PORTB,2		;    ""
	call	pauza
	bcf	PORTB,2
	call	pauza
	call	pauza
	return

right	bsf	PORTB,1		;    ""
	call	pauza
	bcf	PORTB,1
	call	pauza
	call	pauza
	return

escape	bsf	PORTB,0		;    ""
	call	pauza
	bcf	PORTB,0
	call	pauza
	call	pauza
	return

pauza	clrf	paus1		;   60 
	movlw	.78		;   (256 x 3) x 78 = 59 904 
	movwf	paus2
pauz	decfsz	paus1,1
	goto	pauz
	decfsz	paus2,1
	goto	pauz
	return

delay	clrf	delay1		;   400 
	clrf	delay2
	movlw	.2		;   (256 x 3 x 256) x 2 = 393 216 
	movwf	delay3
del	decfsz	delay1,1
	goto	del
	decfsz	delay2,1
	goto	del
	decfsz	delay3,1
	goto	del
	return

play	call	right		;     
	call	right		;    " "
	call	down		;    " "
	call	select		;  ,    " "
				;      
playing	call	ampon		;   
	btfsc	PORTA,2		;     PORTA,0
	bcf	PORTA,0		;  
	btfss	PORTA,2
	bsf	PORTA,0		;     

plays	decfsz	play1,1		;   
	goto	plays
	decfsz	play2,1
	goto	plays
	btfss	PORTA,0		;       ?
	goto	open		;  
close	btfss	PORTA,2		;  ,    ?
	goto	contin		;  ,  
	goto	break		;  ,  
open	btfss	PORTA,2		;  ,    ?
	goto	break		;  ,  
				;  ,  
contin	decfsz	dlitel,1	;   
	goto	plays
break	call	ampoff		;   
	return

stop	call	down		;  ,  
	decfsz	press,1
	goto	stop
	call	select
	call	escape
	btfsc	nomer,5
	movlw	b'00100000'
	btfsc	nomer,5
	subwf	nomer,1

stop1	btfsc	PORTB,5		;      ,
	goto	charge		;     
	bcf	PORTB,6		;     
	goto	begin		;     

limit	movlw	b'00100000'	;  32   
	subwf	nomer,1
	return

ampon	call	delay		;       
	clrf	regon		;    
	movlw	.16		;    
	movwf	regoff

calc1	decf	regoff,1	;    
	incf	regon,1		;    
	movlw	.2		;     
	movwf	regkol2

copy1	movf	regon,0		;  
	movwf	on		;    
	movf	regoff,0	;  
	movwf	off		;    

	bsf	PORTB,4		;  
switch1	decfsz	on,1		;    
	goto	switch1

	bcf	PORTB,4		;  
switch2	decfsz	off,1		;    
	goto	switch2

	decfsz	regkol1,1	;     
	goto	copy1
	decfsz	regkol2,1
	goto	copy1

	movlw	.1
	subwf	regoff,0	;    
	btfss	STATUS,Z	;  
	goto	calc1		;    
	bsf	PORTB,4		;  ,   
	return

ampoff	clrf	regoff		; 
	movlw	.16
	movwf	regon

calc2	decf	regon,1
	incf	regoff,1
	movlw	.1
	movwf	regkol2

copy2	movf	regoff,0
	movwf	off
	movf	regon,0
	movwf	on

	bsf	PORTB,4
switch3	decfsz	on,1
	goto	switch3

	bcf	PORTB,4
switch4	decfsz	off,1
	goto	switch4

	decfsz	regkol1,1
	goto	copy2
	decfsz	regkol2,1
	goto	copy2

	movlw	.1
	subwf	regon,0
	btfss	STATUS,Z
	goto	calc2
	call	delay
	return

vibor	incf	number,1	;     
	decf	number,1	;      
	btfsc	STATUS,Z
	retlw	.85		;  0- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.64		;  1- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.146		;  2- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.116		;  3- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.57		;  4- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.205		;  5- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.155		;  6- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.131		;  7- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.174		;  8- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.92		;  9- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.144		;  10- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.149		;  11- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.174		;  12- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.143		;  13- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.208		;  14- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.135		;  15- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.110		;  16- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.148		;  17- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.154		;  18- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.142		;  19- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.190		;  20- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.143		;  21- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.207		;  22- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.94		;  23- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.153		;  24- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.217		;  25- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.176		;  26- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.147		;  27- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.234		;  28- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.86		;  29- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.56		;  30- 
	decf	number,1
	btfsc	STATUS,Z
	retlw	.128		;  31- 

;-----<   >-----

init	bsf	STATUS,RP0	;  
	movlw	B'00000110'	;   A
	movwf	TRISA
	movlw	B'00000000'	;   
	movwf	TRISB
	bcf	STATUS,RP0	;   
	clrf	PORTA
	clrf	PORTB
	clrf	nomer
	clrf	sposob
	clrf	charge1
	clrf	charge2
	movlw	.1		; (36) x 1 = 36 
	movwf	charge3		;    
	call	escape		;     
	call	right		;     
	call	select		;    
	call	select		;       
	call	escape		;    

;-----<   >------

begin	btfss	PORTA,1		;   
	goto	begin		;   

wait	movlw	.40		;   
	movwf	paus2
	movlw	.3		;   
	movwf	delay2

wai	decfsz	paus1,1		;    
	goto	wai
	decfsz	paus2,1		;    
	goto	wai

test1	btfsc	PORTA,1		;  
	goto	dalee1		;   ,  
	decfsz	delay1,1	;  ,    
	goto	test1		;      
	decfsz	delay2,1
	goto	test1
	goto	ident		;      

dalee1	decfsz	charge1,1	;    
	goto	wait
	decfsz	charge2,1
	goto	wait
	decfsz	charge3,1
	goto	wait
	movlw	.4		; (36) x 4 = 144  =  2,5 
	movwf	charge3		;   
	goto	charg		;     

;-----<   >-----

charge	clrf	paus1
	clrf	paus2
	clrf	paus3
contact	decfsz	paus1,1		;     
	goto	contact
	btfsc	PORTA,1		;   
	goto	char		;  ,   
	decfsz	paus2,1		;   ,   
	goto	contact
	decfsz	paus3,1		; ...
	goto	contact
				;   , ,   (..)
	bcf	PORTB,6		;    
	bcf	PORTB,5		;    
	goto	contact		;    

charg	bsf	PORTB,6		;     
	call	delay		;    
	bsf	PORTB,5		;   

char	movlw	.40		;   
	movwf	paus2
	movlw	.3		;   
	movwf	delay2

cha	decfsz	paus1,1		;    
	goto	cha
	decfsz	paus2,1		;    
	goto	cha

test2	btfsc	PORTA,1		;  
	goto	dalee2		;   , 
	decfsz	delay1,1	;  ,    
	goto	test2		;      
	decfsz	delay2,1
	goto	test2
	goto	ident		;      

dalee2	decfsz	charge1,1	;  ,    
	goto	char
	decfsz	charge2,1
	goto	char
	decfsz	charge3,1
	goto	char
	bcf	PORTB,6		;   
	bcf	PORTB,5		;   
	movlw	.75		; (36) x 75 = 2700  = 45 
	movwf	charge3		;    
	goto	wait		;     

;-----<   >-----

ident	bsf	PORTB,6		;    
	clrf	paus1
	movlw	.150		;     
	movwf	paus2
ident_0	decfsz	paus1,1
	goto	ident_0
	decfsz	paus2,1
	goto	ident_0
	btfss	PORTA,1		;   
	goto	guest		;  ,  
				;  ,  
ident1	clrf	paus1
	clrf	paus2
	movlw	.2		;    
	movwf	paus3
ident_1	decfsz	paus1,1		;    
	goto	ident_1
	btfss	PORTA,1		;   
	goto	ident2
	decfsz	paus2,1
	goto	ident_1
	decfsz	paus3,1
	goto	ident_1		;   
	goto	guest		;  

ident2	clrf	paus1
	movlw	.120
	movwf	paus2
ident_2	decfsz	paus1,1
	goto	ident_2
	decfsz	paus2,1
	goto	ident_2
	btfsc	PORTA,1		;   
	goto	ident4

ident3	clrf	paus1
	clrf	paus2
	movlw	.1
	movwf	paus3
ident_3	decfsz	paus1,1
	goto	ident_3
	decfsz	paus2,1
	goto	ident_3
	decfsz	paus3,1
	goto	ident_3
	btfss	PORTA,1		;   
	goto	user3		;  3-  (.-)
	goto	guest

ident4	clrf	paus1
	clrf	paus2
	movlw	.2
	movwf	paus3
ident_4	decfsz	paus1,1
	goto	ident_4
	btfss	PORTA,1		;   
	goto	user2		;  2-  (...)
	decfsz	paus2,1
	goto	ident_4
	decfsz	paus3,1
	goto	ident_4
	goto	user1		;  1-  (..)

;-------Users--------------------------------------------------

user1	movlw	.107		;   1- 
	movwf	dlitel
	call	right
	call	right
	call	select
	call	playing
	call	escape
	goto	stop1

user2	movlw	.100		;   2- 
	movwf	dlitel
	call	right
	call	right
	call	select
	call	down
	call	playing
	call	escape
	goto	stop1

user3	movlw	.232		;   3- 
	movwf	dlitel
	call	right
	call	right
	call	select
	call	down
	call	down
	call	playing
	call	escape
	goto	stop1

guest	movlw	.0
	subwf	nomer,0		;    nomer  
	btfsc	STATUS,Z	;  nomer   
	incf	sposob,1	;    ,   
	movf	sposob,0	;  ,    
	movwf	spcopy		;      
	movf	nomer,0
	movwf	number		;      

;-----<    >-----

	decf	spcopy,1
	btfsc	STATUS,Z
	goto	sp1
	decf	spcopy,1
	btfsc	STATUS,Z
	goto	sp2
	decf	spcopy,1
	btfsc	STATUS,Z
	goto	sp3
	decf	spcopy,1
	btfsc	STATUS,Z
	goto	sp4
	decf	spcopy,1
	btfsc	STATUS,Z
	goto	sp5
	decf	spcopy,1
	btfsc	STATUS,Z
	goto	sp6
	decf	spcopy,1
	btfsc	STATUS,Z
	goto	sp7
	decf	spcopy,1
	btfsc	STATUS,Z
	goto	sp8
	movlw	.1
	movwf	sposob
	goto	sp1

;-----<   >-----

sp1	call	vibor
	movwf	dlitel
	call	play
	movlw	.1
	movwf	press
	movlw	.1
	addwf	nomer,1
	btfsc	nomer,5		;       32,
	call	limit		;     
	goto	stop

sp2	call	vibor
	movwf	dlitel
	call	play
	movlw	.5
	movwf	press
	movlw	.5
	addwf	nomer,1
	btfsc	nomer,5		;       32,
	call	limit		;     
	goto	stop

sp3	call	vibor
	movwf	dlitel
	call	play
	movlw	.13
	movwf	press
	movlw	.13
	addwf	nomer,1
	btfsc	nomer,5		;       32,
	call	limit		;     
	goto	stop

sp4	call	vibor
	movwf	dlitel
	call	play
	movlw	.7
	movwf	press
	movlw	.7
	addwf	nomer,1
	btfsc	nomer,5		;       32,
	call	limit		;     
	goto	stop

sp5	call	vibor
	movwf	dlitel
	call	play
	movlw	.15
	movwf	press
	movlw	.15
	addwf	nomer,1
	btfsc	nomer,5		;       32,
	call	limit		;     
	goto	stop

sp6	call	vibor
	movwf	dlitel
	call	play
	movlw	.3
	movwf	press
	movlw	.3
	addwf	nomer,1
	btfsc	nomer,5		;       32,
	call	limit		;     
	goto	stop

sp7	call	vibor
	movwf	dlitel
	call	play
	movlw	.11
	movwf	press
	movlw	.11
	addwf	nomer,1
	btfsc	nomer,5		;       32,
	call	limit		;     
	goto	stop

sp8	call	vibor
	movwf	dlitel
	call	play
	movlw	.9
	movwf	press
	movlw	.9
	addwf	nomer,1
	btfsc	nomer,5		;       32,
	call	limit		;     
	goto	stop

	end
